<?php
require_once 'LocalArticleManager.php';
require_once 'Article.php';

/**
 * Die Klasse beinhaltet alle Methoden für die Operation mit den Artikel-Daten.
 *
 * @author Niklas Ortmann
 */
class ArticleManager extends LocalArticleManager
{
    public static function getInstance()
    {
        $articleManager = LocalArticleManager::getInstance(); // TODO: später durch DataBaseArticleManager ersetzen.

        // Erstellen von Dummy-Beiträgen:
        if($articleManager->getArticle(1) == null ){
            $articleManager->addArticle(
                "Satz des Pythagoras",
                "Der Satz des Pythagoras wurde von dem griechischen Philosophen Pythagoras von Samos formuliert und im dritten Jahrhundert vor Christus veröffentlicht. In der beigefügten Abbildung sehen wir ein rechtwinkliges Dreieck...",
                "max.mustermann",
                "Mathe",
                "Dreiecke, Dreiecksseiten berechnen"
            );
        }
        if($articleManager->getArticle(2) == null ){
            $articleManager->addArticle(
                "Tunneleffekt",
                "Der Tunneleffekt ist ein quantenmechanisches Phänomen, bei dem Teilchen...",
                "max.mustermann",
                "Physik",
                "Quantenphysik, Energie"
            );
        }
        if($articleManager->getArticle(3) == null ){
            $articleManager->addArticle(
                "Datenschutz vs Datensicherheit",
                "Datenschutz ist in unserer digital vernetzten Welt allgegenwärtig...",
                "max.mustermann",
                "Informatik",
                "Daten, DSGVO"
            );
        }

        return $articleManager;
    }


    public function search(string $keyword): array 
    {
        $results = [];
        $contentFolder = __DIR__ . '/../content/';
        $files = glob($contentFolder . "*.php");

        foreach ($files as $file) {
            $content = file_get_contents($file);
            if (stripos($content, $keyword) !== false) {
                $filename = basename($file, ".php");
                $results[] = [
                    'title' => ucfirst($filename),
                    'link' => "index.php?pfad=" . $filename
                ];
            }
        }
        return $results;

    }
}